import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import japanize_matplotlib
#import seaborn as sb
import scipy.stats as ss

finnm = input('入力データファイル（*.xlsx）= ')
txtoutnm = input('出力ファイル（*.txt）= ')
txtout = open(txtoutnm, 'w')
foutnm = input('画像保存ファイル（*.png）= ')
#
#      Excelファイルの読み込み
#　　　モジュール xlrd がインストール済みであること
#
xlsx_fl = pd.ExcelFile(finnm)                       #   ExcelファイルからExcelFile型オブジェクトを生成
data_xlsx = pd.read_excel(xlsx_fl,  header = None)  #   ExcelFile型オブジェクトからDataFrame型オブジェクトを生成
data = data_xlsx.values                             #   Dataframe型オブジェクトからnumpyの配列オブジェクトを生成
print('\n', data)

txtout.write('\n入力データファイル: {}\n'.format(finnm))

VarNameX = data[0, 1]
VarNameY = data[0, 2]
txtout.write('\n{0:>10s}{1:>10s}\n'.format(VarNameX, VarNameY))
X = data[1:, 1]
Y = data[1:, 2]
for v in zip(X, Y):
    txtout.write('{0:>10.2f}{1:>10.2f}\n'.format(v[0], v[1]))

results = ss.ttest_rel(X, Y)
tv = results.statistic
df = results.df
pv = results.pvalue
vL, vU = results.confidence_interval(0.95)
print(f'\nt値 = {tv:.5f}    df = {df}   p値(両側) = {pv:.5f}' +
             f'   95% CI = [{vL:.3f}, {vU:.3f}]\n')
txtout.write(f'\nt値 = {tv:.5f}    df = {df}   p値(両側) = {pv:.5f}' +
             f'   95% CI = [{vL:.3f}, {vU:.3f}]\n')
meanX = np.mean(X)
meanY = np.mean(Y)
sdX = np.std(X)
sdY = np.std(Y)
print('\n\n{}：'.format(VarNameX))
print('    平均値＝{0:.2f}    標準偏差＝{1:.2f}'.format(meanX, sdX))
print('\n{}：'.format(VarNameY))
print('    平均値＝{0:.2f}    標準偏差＝{1:.2f}\n'.format(meanY, sdY))

txtout.write('\n\n{}：\n'.format(VarNameX))
txtout.write('    平均値＝{0:.2f}    標準偏差＝{1:.2f}\n'.format(meanX, sdX))
txtout.write('\n{}：\n'.format(VarNameY))
txtout.write('    平均値＝{0:.2f}    標準偏差＝{1:.2f}\n'.format(meanY, sdY))
DiffXY = X - Y
meanXY = np.mean(DiffXY)
sdXY = np.std(DiffXY)

print('\n\n差（{0} - {1}）：'.format(VarNameX, VarNameY))
print('    平均値＝{0:.2f}    標準偏差＝{1:.2f}'.format(meanXY, sdXY))

txtout.write('\n\n差（{0} - {1}）：\n'.format(VarNameX, VarNameY))
txtout.write('    平均値＝{0:.2f}    標準偏差＝{1:.2f}\n'.format(meanXY, sdXY))

SavedFiles = [txtoutnm]

plt.title(('{0}: 平均値 = {1:.2f}'.format(VarNameX, meanX)) +
          ('\n{0}: 平均値 = {1:.2f}'.format(VarNameY, meanY)), fontsize = 18)
plt.hist(X, alpha = 0.5, label = VarNameX)
plt.hist(Y, alpha = 0.5, label = VarNameY)
plt.ylabel('度数', fontsize = 14)
plt.legend()
plt.savefig(foutnm[:-4] + '_XY.png')
SavedFiles.append(foutnm[:-4] + '_XY.png')
plt.show()

plt.title('差({0} - {1})の分布'.format(VarNameX, VarNameY), fontsize = 20)
plt.hist(DiffXY)
plt.ylabel('度数', fontsize = 18)
plt.savefig(foutnm[:-4] + '_Diff.png')
SavedFiles.append(foutnm[:-4] + '_Diff.png')
plt.show()

txtout.close()
print('\n保存ファイル：')
for nm in SavedFiles:
    print('    {}'.format(nm))
print()
